package com.sanjeev.deals.entities;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "FEED_URLS")
public class DataFeedURLInfo implements Serializable {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@Column(name = "RETAILER_NAME")
	private String retailerName;

	@Column(name = "FEED_URL", nullable = false, unique = true)
	private String feedUrl;

	@Column(name = "FEED_CATEGORY")
	private String feedCategory;

	@Column(name = "FEED_SUBCATEGORY")
	private String feedSubcategory;
	
	@Column(name = "FEED_TIME_IN_MINUTES")
	private Integer minutes;

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @return the retailerName
	 */
	public String getRetailerName() {
		return retailerName;
	}

	/**
	 * @return the feedUrl
	 */
	public String getFeedUrl() {
		return feedUrl;
	}

	/**
	 * @return the feedCategory
	 */
	public String getFeedCategory() {
		return feedCategory;
	}

	/**
	 * @return the feedSubcategory
	 */
	public String getFeedSubcategory() {
		return feedSubcategory;
	}

	/**
	 * @return the minutes
	 */
	public Integer getMinutes() {
		return minutes;
	}

	/**
	 * @param minutes the minutes to set
	 */
	public void setMinutes(Integer minutes) {
		this.minutes = minutes;
	}
}
