package com.sanjeev.deals.entities;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Embeddable;

@Embeddable
public class RetailerItemInfo implements Serializable {
	
	@Column(name = "MODEL_NUMBER")
	private String modelNumber;
	
	@Column(name = "RETAILER_NAME")
	private String retailerName;
	
	@Column(name = "RETAILER_ITEM_ID")
	private String retailerItemIdentifier;
	
	@Column(name = "DEAL_TITLE")
	private String dealTitle;
	
	@Column(name = "REGULAR_PRICE", columnDefinition = "DOUBLE default '0.0'")
	//this should be the regular, or non-deal price of this item.
	private Double price = 0.00;
	
	@Column(name = "DEAL_PRICE", columnDefinition = "DOUBLE default '0.0'")
	//this should be the price after rebate and any other offers.
	private Double dealPrice = 0.00;

	@Column(name = "REBATE_IND")
	private boolean rebate;
	
	@Column(name = "FREE_SHIPPING_IND")
	private boolean freeShipping;
	
	@Column(name = "PROMO_CODE_IND")
	private boolean promoCode;
	
	@Column(name = "SHIPPING_COST", columnDefinition = "DOUBLE default '0.0'")
	private Double shippingCost = 0.00;
	
	@Column(name = "DEAL_LIVE_DATE")
	private Date dealLiveDate;
	
	@Column(name = "DEAL_EXPIRE_DATE")
	private Date dealExpirationDate;
	
	@Column(name = "ITEM_URL")
	private String itemURL;
	
	@Column(name = "IMAGE_URL")
	private String imageURL;
	
	@Column(name = "IMAGE_WIDTH")
	private int imageWidth;
	
	@Column(name = "IMAGE_HEIGHT")
	private int imageHeight;

	@Column(name = "ITEM_DESCRIPTION", columnDefinition = "LONGTEXT")
	private String description;
	
	@org.hibernate.annotations.Parent
	private Item item;

	
	/**
	 * @param modelNumber the modelNumber to set
	 */
	public void setModelNumber(String modelNumber) {
		this.modelNumber = modelNumber;
	}
	/**
	 * @return the modelNumber
	 */
	public String getModelNumber() {
		return modelNumber;
	}
	/**
	 * @return the retailerName
	 */
	public String getRetailerName() {
		return retailerName;
	}
	/**
	 * @param retailerName the retailerName to set
	 */
	public void setRetailerName(String retailerName) {
		this.retailerName = retailerName;
	}
	/**
	 * @return the price
	 */
	public Double getPrice() {
		return price;
	}
	/**
	 * @param price the price to set
	 */
	public void setPrice(Double price) {
		this.price = price;
	}
	/**
	 * @return the freeShipping
	 */
	public boolean isFreeShipping() {
		return freeShipping;
	}
	/**
	 * @param freeShipping the freeShipping to set
	 */
	public void setFreeShipping(boolean freeShipping) {
		this.freeShipping = freeShipping;
	}
	/**
	 * @return the shippingCost
	 */
	public Double getShippingCost() {
		return shippingCost;
	}
	/**
	 * @param shippingCost the shippingCost to set
	 */
	public void setShippingCost(Double shippingCost) {
		this.shippingCost = shippingCost;
	}
	/**
	 * @return the dealLiveDate
	 */
	public Date getDealLiveDate() {
		return dealLiveDate;
	}
	/**
	 * @param dealLiveDate the dealLiveDate to set
	 */
	public void setDealLiveDate(Date dealLiveDate) {
		this.dealLiveDate = dealLiveDate;
	}
	/**
	 * @return the dealExpirationDate
	 */
	public Date getDealExpirationDate() {
		return dealExpirationDate;
	}
	/**
	 * @param dealExpirationDate the dealExpirationDate to set
	 */
	public void setDealExpirationDate(Date dealExpirationDate) {
		this.dealExpirationDate = dealExpirationDate;
	}
	/**
	 * @return the retailerItemIdentifier
	 */
	public String getRetailerItemIdentifier() {
		return retailerItemIdentifier;
	}
	/**
	 * @param retailerItemIdentifier the retailerItemIdentifier to set
	 */
	public void setRetailerItemIdentifier(String retailerItemIdentifier) {
		this.retailerItemIdentifier = retailerItemIdentifier;
	}
	/**
	 * @return the itemURL
	 */
	public String getItemURL() {
		return itemURL;
	}
	/**
	 * @param itemURL the itemURL to set
	 */
	public void setItemURL(String itemURL) {
		this.itemURL = itemURL;
	}
	/**
	 * @return the imageURL
	 */
	public String getImageURL() {
		return imageURL;
	}
	/**
	 * @param imageURL the imageURL to set
	 */
	public void setImageURL(String imageURL) {
		this.imageURL = imageURL;
	}
	/**
	 * @return the imageWidth
	 */
	public int getImageWidth() {
		return imageWidth;
	}
	/**
	 * @param imageWidth the imageWidth to set
	 */
	public void setImageWidth(int imageWidth) {
		this.imageWidth = imageWidth;
	}
	/**
	 * @return the imageHeight
	 */
	public int getImageHeight() {
		return imageHeight;
	}
	/**
	 * @param imageHeight the imageHeight to set
	 */
	public void setImageHeight(int imageHeight) {
		this.imageHeight = imageHeight;
	}
	/**
	 * @return the dealPrice
	 */
	public Double getDealPrice() {
		return dealPrice;
	}
	/**
	 * @param dealPrice the dealPrice to set
	 */
	public void setDealPrice(Double dealPrice) {
		this.dealPrice = dealPrice;
	}
	/**
	 * @return the dealTitle
	 */
	public String getDealTitle() {
		return dealTitle;
	}
	/**
	 * @param dealTitle the dealTitle to set
	 */
	public void setDealTitle(String dealTitle) {
		this.dealTitle = dealTitle;
	}
	/**
	 * @return the promoCode
	 */
	public boolean isPromoCode() {
		return promoCode;
	}
	/**
	 * @param promoCode the promoCode to set
	 */
	public void setPromoCode(boolean promoCode) {
		this.promoCode = promoCode;
	}
	/**
	 * @param item the item to set
	 */
	public void setItem(Item item) {
		this.item = item;
	}
	/**
	 * @return the item
	 */
	public Item getItem() {
		return item;
	}
	/**
	 * @return the rebate
	 */
	public boolean isRebate() {
		return rebate;
	}
	/**
	 * @param rebate the rebate to set
	 */
	public void setRebate(boolean rebate) {
		this.rebate = rebate;
	}
	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}	
	/**
	 * @param description the description to set
	 */	
	public void setDescription(String description) {
		this.description = description;;		
	}

	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("RetailerItemInfo [");
		if (dealExpirationDate != null) {
			builder.append("dealExpirationDate=");
			builder.append(dealExpirationDate);
			builder.append(", ");
		}
		if (dealLiveDate != null) {
			builder.append("dealLiveDate=");
			builder.append(dealLiveDate);
			builder.append(", ");
		}
		if (dealPrice != null) {
			builder.append("dealPrice=");
			builder.append(dealPrice);
			builder.append(", ");
		}
		if (dealTitle != null) {
			builder.append("dealTitle=");
			builder.append(dealTitle);
			builder.append(", ");
		}
		builder.append("freeShipping=");
		builder.append(freeShipping);
		builder.append(", ");
//		if (id != null) {
//			builder.append("id=");
//			builder.append(id);
//			builder.append(", ");
//		}
		builder.append("imageHeight=");
		builder.append(imageHeight);
		builder.append(", ");
		if (imageURL != null) {
			builder.append("imageURL=");
			builder.append(imageURL);
			builder.append(", ");
		}
		builder.append("imageWidth=");
		builder.append(imageWidth);
		builder.append(", ");
		if (item.getModelNumber() != null) {
			builder.append("item=");
			builder.append(item.getModelNumber());
			builder.append(", ");
		}
		if (modelNumber != null) {
			builder.append("modelNumber=");
			builder.append(modelNumber);
			builder.append(", ");
		}
		if (price != null) {
			builder.append("price=");
			builder.append(price);
			builder.append(", ");
		}
		builder.append("promoCode=");
		builder.append(promoCode);
		builder.append(", ");
		if (retailerItemIdentifier != null) {
			builder.append("retailerItemIdentifier=");
			builder.append(retailerItemIdentifier);
			builder.append(", ");
		}
		if (retailerName != null) {
			builder.append("retailerName=");
			builder.append(retailerName);
			builder.append(", ");
		}
		if (shippingCost != null) {
			builder.append("shippingCost=");
			builder.append(shippingCost);
		}
		builder.append("]");
		return builder.toString();
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime
				* result
				+ ((dealExpirationDate == null) ? 0 : dealExpirationDate
						.hashCode());
		result = prime * result
				+ ((dealPrice == null) ? 0 : dealPrice.hashCode());
		result = prime * result
				+ ((dealTitle == null) ? 0 : dealTitle.hashCode());
		result = prime * result + (freeShipping ? 1231 : 1237);
		result = prime * result
				+ ((modelNumber == null) ? 0 : modelNumber.hashCode());
		result = prime * result + ((price == null) ? 0 : price.hashCode());
		result = prime * result + (promoCode ? 1231 : 1237);
		result = prime
				* result
				+ ((retailerItemIdentifier == null) ? 0
						: retailerItemIdentifier.hashCode());
		result = prime * result
				+ ((retailerName == null) ? 0 : retailerName.hashCode());
		result = prime * result
				+ ((shippingCost == null) ? 0 : shippingCost.hashCode());
		return result;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RetailerItemInfo other = (RetailerItemInfo) obj;
		if (dealExpirationDate == null) {
			if (other.dealExpirationDate != null)
				return false;
		} else if (!dealExpirationDate.equals(other.dealExpirationDate))
			return false;
		if (dealPrice == null) {
			if (other.dealPrice != null)
				return false;
		} else if (!dealPrice.equals(other.dealPrice))
			return false;
		if (dealTitle == null) {
			if (other.dealTitle != null)
				return false;
		} else if (!dealTitle.equals(other.dealTitle))
			return false;
		if (freeShipping != other.freeShipping)
			return false;
		if (modelNumber == null) {
			if (other.modelNumber != null)
				return false;
		} else if (!modelNumber.equals(other.modelNumber))
			return false;
		if (price == null) {
			if (other.price != null)
				return false;
		} else if (!price.equals(other.price))
			return false;
		if (promoCode != other.promoCode)
			return false;
		if (retailerItemIdentifier == null) {
			if (other.retailerItemIdentifier != null)
				return false;
		} else if (!retailerItemIdentifier.equals(other.retailerItemIdentifier))
			return false;
		if (retailerName == null) {
			if (other.retailerName != null)
				return false;
		} else if (!retailerName.equals(other.retailerName))
			return false;
		if (shippingCost == null) {
			if (other.shippingCost != null)
				return false;
		} else if (!shippingCost.equals(other.shippingCost))
			return false;
		return true;
	}
}
