package com.sanjeev.deals.entities.dao;

import java.util.List;

import org.hibernate.Session;

import com.sanjeev.deals.entities.DataFeedURLInfo;

public class DataFeedURLInfoDAO {

	private Session session;

	public DataFeedURLInfoDAO(Session session) {
		this.session = session;
	}

	public List<DataFeedURLInfo> getDataFeedURLByVendor(String vendor) {
		return session.createQuery(
				"from DataFeedURLInfo where retailerName = ?").setString(1,
				vendor).list();
	}

	public List<DataFeedURLInfo> getDataFeedURLByTime(long minutes) {
		return session
				.createQuery(
						"from DataFeedURLInfo where minutes >= :lowerLimit and minutes < :upperLimit")
				.setLong("lowerLimit", (minutes - 30)).setLong("upperLimit",
						minutes).list();
	}
}
